#!/bin/sh

#  $Revision: 1.1 $
#bcpyrght
#***************************************************************************
#* $VRTScprght: Copyright 1993 - 2001 VERITAS Software Corporation, All Rights Reserved $ *
#***************************************************************************
#ecpyrght
#
# Script used to update the NCVU_media_server utility with the path to PERL
#
# install_NCVU_media_server.sh
#
# Usage:
# install_NCVU_media_server.sh

answer="no"

while [ "$answer" != "1" ] && [ "$answer" != "2" ]
do
  clear
  echo "Welcome to the validate NetBackup media server configuration installation"
  echo "program.\n"
  echo "Please select the method of installation that you would like to use.\n"
  echo "1.  Manually update the NCVU_media_server file with the appropriate path"
  echo "    to Perl version 5.003.\n"
  echo "2.  The installation script will:\n"
  echo "      A.  Prompt for the directory location to search for copies of"
  echo "          PERL.\n"
  echo "      B.  Locate any copies of Perl 5.003 that exist beneath the root"
  echo "          directory.\n"
  echo "      C.  Prompt for the verification of which copy of Perl to use.\n"
  echo "      D.  Update the NCVU_media_server file with the path to the selected\n"
  echo "          copy of Perl.\n\n"
  echo "Read the README file for instructions on how to run NCVU_media_server.\n\n"
  echo "          Selection [1/2] \c"

  read answer
done

case "$answer" in
1)
  exit
;;
2)
 echo "\nPlease enter the absolute path for the installation script to search for"
 echo "PERL version 5.003 or greater:\n"

 read path

 echo "\nSearching for PERL beginning at:\n"
 echo "${path}"

 find ${path} -name perl -print > temp.list
;;
esac

echo "\nChecking located copies of perl for minimum version requirements."

cat temp.list | while read path_perl
do
  version=`${path_perl} -version |egrep "This is perl"|awk -F" " '{printf("%s",substr ($5,1,5))}'`
  status=$?
  if [ "$status" = 0 ]
  then
    if [ "$version" -ge "5.003" ]
    then
      echo "$path_perl" >> perl.list
    fi
  fi
done

number_files=`wc -l perl.list|sed s/perl.list//|sed s/\ *//`

if [ "$number_files" -gt "0" ]
then
  echo "\nThe install script will now list the copies of Perl version 5.003 or"
  echo "higher that were located.  Once you have determined the copy you wish"
  echo "to use to run the NCVU_media_server utility, enter the number associated"
  echo "with your selection, n to continue listing any subsequent copies of Perl"
  echo "or q to quit.\n"

  i=1

  for perl_path in `cat perl.list`
  do
    echo "$i\t$perl_path"
    line=`expr "$i" % 22`

    if [ "$i" -lt 10 ]
    then
      first_digit=$i
    elif [ "$i" -lt 100 ]
    then
      first_digit=`echo "$i"|awk -F" " '{printf("%s",substr($0,2,2))}'`
      second_digit=`echo "$i"|awk -F" " '{printf("%s",substr($0,1,1))}'`
    fi 

    if [ $line -eq 0 ]
    then
      valid_selection="no"
      echo ""

      while [ "$valid_selection" = "no" ]
      do
        echo "          Selection [#/n/q] \c"
        read answer
        answer=`echo "$answer" |tr A-Z a-z`

        if [ "$i" -lt 10 ]
        then
          case "$answer" in
          q) 
            exit ;;
          n)
            valid_selection="next"
            clear;;
          [1-$first_digit])
            echo "selected number = $answer"
            valid_selection="yes";;
          *) 
            ;;
          esac
        elif [ "$i" -lt 100 ]
        then
          case "$answer" in
          q) 
            exit ;;
          n)
            valid_selection="next"
            clear;;
          [1-`expr "$second_digit" - 1`][0-9])
            valid_selection="yes";;
          [1-$second_digit][0-$first_digit])
            valid_selection="yes";;
          [1-9])
            valid_selection="yes";;
          *) 
            ;;
          esac
        fi
      done
    fi

    if [ "$valid_selection" = "yes" ]
    then
      break
    fi

    if [ "$i" -eq "$number_files" ]
    then
      break
    fi

    i=`expr "$i" + 1`
  done

  while [ "$valid_selection" != "yes" ]
  do
    echo "         Selection [#/q] \c"
    read answer
    answer=`echo "$answer" |tr A-Z a-z`

    if [ "$i" -lt 10 ]
    then
      first_digit=$i
    elif [ "$i" -lt 100 ]
    then
      first_digit=`echo "$i"|awk -F" " '{printf("%s",substr($0,2,2))}'`
      second_digit=`echo "$i"|awk -F" " '{printf("%s",substr($0,1,1))}'`
    fi 
    
    if [ "$i" -lt 10 ]
    then
      case "$answer" in
      q) 
        exit ;;
      [1-$first_digit])
        valid_selection="yes";;
      *) 
        ;;
      esac
    elif [ "$i" -lt 100 ]
    then
      case "$answer" in
      q) 
        exit ;;
      [1-`expr "$second_digit" - 1`][0-9])
        valid_selection="yes";;
      [1-$second_digit][0-$first_digit])
        valid_selection="yes";;
      [1-9])
        valid_selection="yes";;
      *) 
        ;;
      esac
    fi
  done

  i=1

  echo "\nUpdating NCVU_media_server.\n"

  for perl_path in `cat perl.list`
  do
    if [ "$i" -eq "$answer" ]
    then
      echo "#!\c" > temp.file
      echo "$perl_path" >> temp.file
      cat NCVU_media_server >> temp.file
      mv temp.file NCVU_media_server
      rm perl.list temp.list

      if [ ! -x NCVU_media_server ]
      then
        /usr/bin/chmod u+x NCVU_media_server
      fi

      break
    else
      i=`expr "$i" + 1`
    fi
  done
else
  echo "There were no copies of Perl found that were version 5.003 or higher."
  echo "Please install Perl version 5.003 or higher and run the installation"
  echo "script again."
  exit 1
fi
